/*

Przygotowanie bazy danych

drop table Osoba;
drop table Jednostka;

create table Jednostka( ID int not null, Nazwa varchar2(20) );

begin
  insert into Jednostka values( 1, 'Wrocaw' );
  insert into Jednostka values( 2, 'Pozna' );
  insert into Jednostka values( 3, 'Krakw' );
  insert into Jednostka values( 4, 'Warszawa' );
end;

create table Osoba( ID int not null primary key, ID_Jednostka int, Imie varchar2(30), Nazwisko varchar2(50), Pensja int)

begin
  insert into Osoba values( 1, 1, 'Jan', 'Kowalski', 1000 );
  insert into Osoba values( 2, 3, 'Ewa', 'Solska', 1200 );
  insert into Osoba values( 3, 2, 'Boydar', 'Nowak', 1500 );
  insert into Osoba values( 4, 4, 'Adam', 'Adamski', 1700 );
  insert into Osoba values( 5, 4, 'Zygmunt', 'Riposta', 1240 );
  insert into Osoba values( 6, 2, 'Alicja', 'Gleba', 1600 );
  insert into Osoba values( 7, 1, 'Tania', 'Borwka', 1560 );
  insert into Osoba values( 8, 1, 'Natasza', 'Lizacka', 2500 );
  insert into Osoba values( 9, 3, 'Stan', 'Taczkowski', 1900 );
end;

select * from Osoba o, Jednostka j where o.ID_Jednostka = j.ID;
*/


import com.sun.rowset.CachedRowSetImpl;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import javax.sql.rowset.CachedRowSet;
import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JTextField;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
import oracle.jdbc.pool.OracleDataSource;

public class ListComboBinding extends JFrame {
    private JList lstOsoby = new JList();
    private JComboBox cbJednostki = new JComboBox();
    private JButton btnAdd = new JButton();
    private JButton btnDelete = new JButton();
    private JTextField txtElement = new JTextField();
    private CustomListModel listModel;

    static final long serialVersionUID = 23482738;
    
    public ListComboBinding() {
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        Database db = new Database();

        cbJednostki.setModel(new CustomComboBoxModel(db.getRowSet("SELECT Nazwa FROM Jednostka")));
        cbJednostki.setSelectedIndex(0);
        
        listModel = new CustomListModel(db.getRowSet("SELECT Imie, Nazwisko FROM Osoba WHERE ID_Jednostka=(SELECT MAX(ID) FROM Jednostka WHERE Nazwa='"+cbJednostki.getSelectedItem()+"') ORDER BY 2"));
        listModel.addListDataListener(new CustomDataListener());
        lstOsoby.setModel(listModel);

        this.getContentPane().setLayout(null);
        this.setSize(new Dimension(166, 302));
        lstOsoby.setBounds(new Rectangle(5, 35, 145, 175));
        cbJednostki.setBounds(new Rectangle(5, 5, 145, 25));
        cbJednostki.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        cbJednostki_actionPerformed(e);
                    }
                });
        btnAdd.setText("Dodaj");
        btnAdd.setBounds(new Rectangle(5, 240, 71, 23));
        btnAdd.setActionCommand("add");
        btnAdd.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        btnAdd_actionPerformed(e);
                    }
                });
        btnDelete.setText("Usun");
        btnDelete.setBounds(new Rectangle(80, 240, 71, 23));
        btnDelete.setActionCommand("delete");
        btnDelete.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        btnDelete_actionPerformed(e);
                    }
                });
        txtElement.setBounds(new Rectangle(5, 215, 145, 20));
        this.getContentPane().add(txtElement, null);
        this.getContentPane().add(btnDelete, null);
        this.getContentPane().add(btnAdd, null);
        this.getContentPane().add(cbJednostki, null);
        this.getContentPane().add(lstOsoby, null);
        this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        this.setVisible(true);
    }

    public static void main(String[] args) {
        new ListComboBinding();
    }

    private void cbJednostki_actionPerformed(ActionEvent e) {
        Database db = new Database();
        listModel = new CustomListModel(db.getRowSet("SELECT Imie, Nazwisko FROM Osoba WHERE ID_Jednostka=(SELECT MAX(ID) FROM Jednostka WHERE Nazwa='"+cbJednostki.getSelectedItem()+"') ORDER BY 2"));
        listModel.addListDataListener(new CustomDataListener());
        lstOsoby.setModel(listModel);        
        lstOsoby.repaint();
    }

    private void btnAdd_actionPerformed(ActionEvent e) {
        if (txtElement.getText().equals("")) return;

        int index = lstOsoby.getSelectedIndex();
        int size = listModel.getSize();

        if (index == -1 || (index+1 == size)) {
            listModel.addElement(txtElement.getText());
            lstOsoby.setSelectedIndex(size);
        } else {
            listModel.insertElementAt(txtElement.getText(), index+1);
            lstOsoby.setSelectedIndex(index+1);
        }
        btnDelete.setEnabled(true);
    }

    private void btnDelete_actionPerformed(ActionEvent e) {
        int firstSelected = lstOsoby.getSelectionModel().getMinSelectionIndex();
        int lastSelected = lstOsoby.getSelectionModel().getMaxSelectionIndex();
        listModel.removeRange(firstSelected, lastSelected);

        int size = listModel.size();

        if (size == 0) {
            btnDelete.setEnabled(false);
        } else {
            if (firstSelected == listModel.getSize()) firstSelected--;
            lstOsoby.setSelectedIndex(firstSelected); 
        }

    }
}

class Database {
    public OracleDataSource getDataSource() throws ClassNotFoundException {
        OracleDataSource ds = null;
        try {
            ds = new OracleDataSource();
            ds.setURL("jdbc:oracle:thin:pawel/oracle10g@localhost:1521:XE");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return ds;
    }

    public CachedRowSet getRowSet(String sql) {
        CachedRowSet rowset = null;
        try {
            OracleDataSource ds = getDataSource();
            Connection conn = ds.getConnection();
            rowset = new CachedRowSetImpl();
            rowset.setType(ResultSet.TYPE_SCROLL_INSENSITIVE);
            rowset.setTransactionIsolation(Connection.TRANSACTION_READ_COMMITTED);
            rowset.release();
            rowset.setCommand(sql);
            rowset.execute(conn);
            conn.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return rowset;
    }
}

class CustomListModel extends DefaultListModel {
    static final long serialVersionUID = 49383948;
    public CustomListModel(CachedRowSet rs) {
        try {
            rs.beforeFirst();
            while (rs.next())
            this.addElement(rs.getString("Imie") + " " + rs.getString("Nazwisko"));
        }
        catch (SQLException ex) { }
    }
}

class CustomDataListener implements ListDataListener {
    public void contentsChanged(ListDataEvent e) {
        // Naley dopisac kod, ktory odpowiednio zmodyfikuje RowSet
        System.out.println("contentsChanged: " + e.getIndex0() +", " + e.getIndex1()); 
    }
    public void intervalAdded(ListDataEvent e) {
        // Naley dopisac kod, ktory odpowiednio zmodyfikuje RowSet
        System.out.println("intervalAdded: " + e.getIndex0() + ", " + e.getIndex1()); 
    }
    public void intervalRemoved(ListDataEvent e) {
        // Naley dopisac kod, ktory odpowiednio zmodyfikuje RowSet
        System.out.println("intervalRemoved: " + e.getIndex0() + ", " + e.getIndex1()); 
    }
}


class CustomComboBoxModel extends DefaultComboBoxModel {
    static final long serialVersionUID = 493383948;
    CachedRowSet rs = null;

    public CustomComboBoxModel(CachedRowSet rs) {
        this.rs = rs;
    }

    public int getSize() {
        return rs.size();
    }

    public Object getElementAt(int index) {
        try {
            rs.absolute(index + 1);
            return rs.getString("Nazwa");
        } catch (SQLException e) {
            return null;
        }
    }
}

