import java.awt.Dimension;

import java.awt.Rectangle;

import javax.swing.JFrame;
import javax.swing.JTree;
import javax.swing.event.TreeModelEvent;
import javax.swing.event.TreeModelListener;
import javax.swing.tree.*;

public class TreeBinding extends JFrame {
    static final long serialVersionUID = 48574875;
    private JTree tree = new JTree();

    public TreeBinding() {
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        DefaultMutableTreeNode root = new DefaultMutableTreeNode("Przedstawiciele", true);

        DefaultMutableTreeNode wroclaw = new DefaultMutableTreeNode("Wroclaw", true);
        DefaultMutableTreeNode krakow = new DefaultMutableTreeNode("Krakow", true);
        DefaultMutableTreeNode poznan = new DefaultMutableTreeNode("Poznan", true);
        DefaultMutableTreeNode warszawa = new DefaultMutableTreeNode("Warszawa", true);
        
        DefaultMutableTreeNode wroclaw_g1 = new DefaultMutableTreeNode("A-F");
        DefaultMutableTreeNode wroclaw_g2 = new DefaultMutableTreeNode("G-L");
        DefaultMutableTreeNode wroclaw_g3 = new DefaultMutableTreeNode("M-P");
        DefaultMutableTreeNode wroclaw_g4 = new DefaultMutableTreeNode("R-Z");

        DefaultMutableTreeNode krakow_g1 = new DefaultMutableTreeNode("A-F");
        DefaultMutableTreeNode krakow_g2 = new DefaultMutableTreeNode("G-L");
        DefaultMutableTreeNode krakow_g3 = new DefaultMutableTreeNode("M-P");
        DefaultMutableTreeNode krakow_g4 = new DefaultMutableTreeNode("R-Z");

        DefaultMutableTreeNode poznan_g1 = new DefaultMutableTreeNode("A-F");
        DefaultMutableTreeNode poznan_g2 = new DefaultMutableTreeNode("G-L");
        DefaultMutableTreeNode poznan_g3 = new DefaultMutableTreeNode("M-P");
        DefaultMutableTreeNode poznan_g4 = new DefaultMutableTreeNode("R-Z");

        DefaultMutableTreeNode warszawa_g1 = new DefaultMutableTreeNode("A-F");
        DefaultMutableTreeNode warszawa_g2 = new DefaultMutableTreeNode("G-L");
        DefaultMutableTreeNode warszawa_g3 = new DefaultMutableTreeNode("M-P");
        DefaultMutableTreeNode warszawa_g4 = new DefaultMutableTreeNode("R-Z");

        wroclaw.insert(wroclaw_g1, 0);        
        wroclaw.insert(wroclaw_g2, 1);        
        wroclaw.insert(wroclaw_g3, 2);        
        wroclaw.insert(wroclaw_g4, 3);
        
        krakow.insert(krakow_g1, 0);
        krakow.insert(krakow_g2, 1);
        krakow.insert(krakow_g3, 2);
        krakow.insert(krakow_g4, 3);
        
        poznan.insert(poznan_g1, 0);
        poznan.insert(poznan_g2, 1);
        poznan.insert(poznan_g3, 2);
        poznan.insert(poznan_g4, 3);
        
        warszawa.insert(warszawa_g1, 0);
        warszawa.insert(warszawa_g2, 1);
        warszawa.insert(warszawa_g3, 2);
        warszawa.insert(warszawa_g4, 3);
        
        root.insert(wroclaw, 0);
        root.insert(krakow, 1);
        root.insert(poznan, 2);
        root.insert(warszawa, 3);
    
        DefaultTreeModel tm = new DefaultTreeModel(root);
        tm.addTreeModelListener(new CustomTreeModelListener());
        tree.setModel(tm);
    
        this.getContentPane().setLayout( null );
        this.setSize( new Dimension(400, 300) );
        tree.setBounds(new Rectangle(5, 5, 175, 255));
        tree.setEditable(true);
        this.getContentPane().add(tree, null);
        this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        this.setVisible(true);
    }
    
    public static void main(String[] args) {
        new TreeBinding();
    }
}

class CustomTreeModelListener implements TreeModelListener {
    public void treeNodesChanged(TreeModelEvent e) {
        DefaultMutableTreeNode node;
        node = (DefaultMutableTreeNode)(e.getTreePath().getLastPathComponent());
        try {
            Object[] test = e.getTreePath().getPath();
            for (int k=0; k<test.length; k++ ) System.out.print(test[k].toString()+",");
    //        int index = e.getChildIndices()[0];
    //        node = (DefaultMutableTreeNode)(node.getChildAt(index));
        }
        catch (NullPointerException ex) { }
        System.out.println("The user has finished editing the node.");
        System.out.println("New value: " + node.getUserObject());
    }

    public void treeNodesInserted(TreeModelEvent e) {
        System.out.println(e);
    }

    public void treeNodesRemoved(TreeModelEvent e) {
        System.out.println(e);
    }

    public void treeStructureChanged(TreeModelEvent e) {
        System.out.println(e);
    }
}

