/*
Przygotowanie bazy danych:

drop table test;
create table test ( id int primary key, name varchar(20) );

begin
  insert into test values( 1, 'Asia' );
  insert into test values( 2, 'Basia' );
  insert into test values( 3, 'Kasia' );
end;

select * from test;
 */

import java.sql.*;
import javax.sql.*;
import javax.naming.*;
import com.microsoft.sqlserver.jdbc.*;

public class JNDIExample {
    private static final String DS_ENTRY = "Library";
    private static final String CONTEXT_FACTORY = "com.sun.jndi.fscontext.RefFSContextFactory";

    public JNDIExample()
    {
        bindDataSource();
        runQuery();
    }

    public static void main(String[] args)
    {
        new JNDIExample();
    }

    public void bindDataSource()
    {
        try
        {
            Context ctx = new InitialContext();
            ctx.addToEnvironment(Context.INITIAL_CONTEXT_FACTORY, CONTEXT_FACTORY);
            
        	SQLServerDataSource ds = new SQLServerDataSource();
			ds.setServerName("localhost");
			ds.setPortNumber(1433); 
			ds.setUser( "sa" );
			ds.setPassword("sql2005");
			ds.setDatabaseName("KursBD");            
            ctx.unbind(DS_ENTRY);
            ctx.bind(DS_ENTRY, ds);
        }
        catch (NamingException ne)
        {
            ne.printStackTrace();
        }
    }

    public void runQuery()
    {
        try
        {
            Context ctx = new InitialContext();
            ctx.addToEnvironment(Context.INITIAL_CONTEXT_FACTORY, CONTEXT_FACTORY);
            DataSource ds = (DataSource)ctx.lookup(DS_ENTRY);
            Connection connection = ds.getConnection();
            
            Statement stmt = connection.createStatement();
            ResultSet rs = stmt.executeQuery("SELECT Id, Name FROM Test");
            while (rs.next())
                System.out.println(String.format("%s %s", rs.getString("ID"), rs.getString("Name")));
            stmt.close();
            connection.close();
        }
        catch (NamingException ne)
        {
            ne.printStackTrace();
        }
        catch (SQLException se)
        {
            se.printStackTrace();
        }
    }
}
