/*
Na podstawie przykadw z pakietu:
JDBCTM RowSet Implementations
JavaTM Web Services Pack v1.4 Co-Bundle
*/

import java.sql.SQLException;
import javax.sql.rowset.CachedRowSet;
import com.sun.rowset.CachedRowSetImpl;

/*
 Przygotowanie bazy danych

 create table Osoba( ID int not null primary key, Imie varchar2(30), Nazwisko varchar2(50), Pensja int)

 begin
   insert into Osoba values( 1, 'Jan', 'Kowalski', 1000 );
   insert into Osoba values( 2, 'Ewa', 'Solska', 1200 );
   insert into Osoba values( 3, 'Boydar', 'Nowak', 1500 );
   insert into Osoba values( 4, 'Adam', 'Adamski', 1700 );
   insert into Osoba values( 5, 'Zygmunt', 'Riposta', 1240 );
   insert into Osoba values( 6, 'Alicja', 'Gleba', 1600 );
   insert into Osoba values( 7, 'Tania', 'Borwka', 1560 );
   insert into Osoba values( 8, 'Natasza', 'Lizacka', 2500 );
   insert into Osoba values( 9, 'Stan', 'Taczkowski', 1900 );
 end;

 select * from Osoba;

 */

public class CachedRowSetSample {

    public static void main(String[] args) {

        // Declaration of all the variables used
        String dbUrl = "jdbc:oracle:thin:@localhost:1521:XE";
        String dbUserId = "pawel";
        String dbPasswd = "oracle10g";
        String dbDriver = "oracle.jdbc.driver.OracleDriver";
        String dbCommand = "select * from OSOBA";

        int i = 0;

        CachedRowSet crs;

        try {
            Class.forName(dbDriver);
        } catch (Exception e) {
            System.out.println("Unable to load driver: " + e.getMessage());
            System.exit(1);
        }

        try {
            crs = new CachedRowSetImpl();

            crs.setUrl(dbUrl);
            crs.setUsername(dbUserId);
            crs.setPassword(dbPasswd);
            crs.setCommand(dbCommand);

            crs.setPageSize(4);

            crs.execute();

            while (crs.nextPage()) {
                System.out.println("Page number: " + (i++));
                while (crs.next()) {
                    if (crs.getInt("Pensja") < 1400) {
                        System.out.println("Zwikszamy pensj o 199 z dla " + 
                                           crs.getString("Nazwisko") + " " + 
                                           crs.getString("Imie"));
                        crs.updateInt("Pensja", crs.getInt("Pensja") + 199);
                        crs.updateRow();
                        crs.acceptChanges();
                    }
                }
            }

            crs.previousPage();
            crs.moveToInsertRow();
            crs.updateInt("ID", 20);
            crs.updateString("Imie", "Witold");
            crs.updateString("Nazwisko", "Nuworysz");
            crs.updateInt("Pensja", 1999);
            crs.insertRow();
            crs.moveToCurrentRow();

            crs.acceptChanges();

            crs.close();

        } catch (SQLException sqle) {
            sqle.printStackTrace();
            System.out.println("Caught SQLException: " + sqle.getMessage());
        } catch (Exception e) {
            System.out.println("Caught unexpected Exception: " + 
                               e.getMessage());
        }
    }
} 