/*
Na podstawie przykadow z pakietu:
JDBCTM RowSet Implementations
JavaTM Web Services Pack v1.4 Co-Bundle
*/

 /*
  Przygotowanie bazy danych

  create table Osoba( ID int not null primary key, Imie varchar2(30), Nazwisko varchar2(50), Pensja int)

  begin
    insert into Osoba values( 1, 'Jan', 'Kowalski', 1000 );
    insert into Osoba values( 2, 'Ewa', 'Solska', 1200 );
    insert into Osoba values( 3, 'Boydar', 'Nowak', 1500 );
    insert into Osoba values( 4, 'Adam', 'Adamski', 1700 );
    insert into Osoba values( 5, 'Zygmunt', 'Riposta', 1240 );
    insert into Osoba values( 6, 'Alicja', 'Gleba', 1600 );
    insert into Osoba values( 7, 'Tania', 'Borwka', 1560 );
    insert into Osoba values( 8, 'Natasza', 'Lizacka', 2500 );
    insert into Osoba values( 9, 'Stan', 'Taczkowski', 1900 );
  end;

  select * from Osoba;

  */
 
 import java.sql.*;
 import javax.sql.rowset.*;
 import com.sun.rowset.*;
 
 public class FilteredRowSetSample2 {
 
    public static void main(String [] args) {
    
       // Declaration of all the variables used
        String dbUrl = "jdbc:oracle:thin:@localhost:1521:XE";
        String dbUserId = "pawel";
        String dbPasswd = "oracle10g";
        String dbDriver = "oracle.jdbc.driver.OracleDriver";
        String dbCommand = "select ID, Nazwisko, Imie, Pensja from Osoba"; 
        int [] idxArray = {4,2}; 
        Object [] loArray = {new Integer(1600), "Adamski"};
        Object [] hiArray = {new Integer(1700), "Gleba"};

       try {
          Class.forName(dbDriver);
       } catch(Exception e) {
          System.out.println("Unable to load driver: "+e.getMessage());
          System.exit(1);
       }              
       
       try
       {
       
          Class.forName(dbDriver);
          Connection con = DriverManager.getConnection(dbUrl,dbUserId,dbPasswd);    	  
	  
	  FilteredRowSet frs = new FilteredRowSetImpl();
	  frs.setUsername(dbUserId);
	  frs.setPassword(dbPasswd);
	  frs.setUrl(dbUrl);
	  frs.setCommand(dbCommand);
	  frs.execute();
	  
	  Range3 combinedFilter = new Range3(loArray,hiArray,idxArray);
	  frs.setFilter(combinedFilter);	  	  
	  
	  while(frs.next()) {
	     System.out.println("Store record is: "+frs.getInt(1)+" "+frs.getString(2));
	  }
	   frs.close();
	   con.close();
	   	  
       } catch(Exception e ) {
          System.err.println("Caught unexpected Exception: "+e.getMessage());       
       } 
    }
 }