/*
Na podstawie przykadow z pakietu:
JDBCTM RowSet Implementations
JavaTM Web Services Pack v1.4 Co-Bundle
*/

/*
 Przygotowanie bazy danych

 create table Osoba( ID int not null primary key, Imie varchar2(30), Nazwisko varchar2(50), Pensja int)

 begin
   insert into Osoba values( 1, 'Jan', 'Kowalski', 1000 );
   insert into Osoba values( 2, 'Ewa', 'Solska', 1200 );
   insert into Osoba values( 3, 'Boydar', 'Nowak', 1500 );
   insert into Osoba values( 4, 'Adam', 'Adamski', 1700 );
   insert into Osoba values( 5, 'Zygmunt', 'Riposta', 1240 );
   insert into Osoba values( 6, 'Alicja', 'Gleba', 1600 );
   insert into Osoba values( 7, 'Tania', 'Borwka', 1560 );
   insert into Osoba values( 8, 'Natasza', 'Lizacka', 2500 );
   insert into Osoba values( 9, 'Stan', 'Taczkowski', 1900 );
 end;

 select * from Osoba;

 */
 
 import java.sql.*;
 
 import javax.sql.rowset.*;
 import com.sun.rowset.*;
 
 public class JdbcRowSetSample {
 
    public static void main(String [] args) {
       String dbUrl = "jdbc:oracle:thin:@localhost:1521:XE";
       String dbUserId = "pawel";
       String dbPasswd = "oracle10g";
       String dbDriver = "oracle.jdbc.driver.OracleDriver";
       String dbCommand = "select ID, Nazwisko, Imie, Pensja from Osoba"; // Nie mona uy gwiazdki
       ResultSet res = null;
       Connection con = null;
       Statement stmt = null;
              
       JdbcRowSet jdbcRs;
       
       try {
          Class.forName(dbDriver);
       } catch(Exception e) {
          System.out.println("Unable to load driver: "+e.getMessage());
          System.exit(1);
       }
       
       try
       {                             
          con = DriverManager.getConnection(dbUrl,dbUserId,dbPasswd);                    
      
      	  stmt = con.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_UPDATABLE);     
          res = stmt.executeQuery(dbCommand);
                 
          jdbcRs = new JdbcRowSetImpl(res);
                    
          jdbcRs.absolute(3);
          jdbcRs.updateInt("Pensja",3000);
          jdbcRs.updateRow();
      
          jdbcRs.first();
                    
          jdbcRs.moveToInsertRow();
          jdbcRs.updateInt("ID",20);
          jdbcRs.updateString("Imie","Anastazja");
          jdbcRs.updateString("Nazwisko","Tulipana");          
          jdbcRs.updateInt("Pensja", 2111);
          jdbcRs.insertRow();
          jdbcRs.moveToCurrentRow();
      
          jdbcRs.moveToInsertRow();
          jdbcRs.updateInt("ID",21);
          jdbcRs.updateString("Imie","Marta");
          jdbcRs.updateString("Nazwisko","Sosna");          
          jdbcRs.updateInt("Pensja", 3211);
          jdbcRs.insertRow();
          jdbcRs.moveToCurrentRow();
                    
          jdbcRs.last();
          jdbcRs.deleteRow();
          
          jdbcRs.close();          
          
       } catch (SQLException sqle) {
          sqle.printStackTrace();
          System.out.println("Caught SQLException: "+sqle.getMessage());
       } catch (Exception e) {
          e.printStackTrace();
          System.out.println("Unexpected Exception caught: "+e.getMessage());
       }
       
    }
 }    