 /*
 Na podstawie przykadow z pakietu:
 JDBCTM RowSet Implementations
 JavaTM Web Services Pack v1.4 Co-Bundle
 */

/*
 Przygotowanie bazy danych

drop table Osoba;
drop table Jednostka;

create table Jednostka( ID int not null, Nazwa varchar2(20) );

begin
  insert into Jednostka values( 1, 'Wrocaw' );
  insert into Jednostka values( 2, 'Pozna' );
  insert into Jednostka values( 3, 'Krakw' );
  insert into Jednostka values( 4, 'Warszawa' );
end;

create table Osoba( ID int not null primary key, ID_Jednostka int, Imie varchar2(30), Nazwisko varchar2(50), Pensja int)

begin
  insert into Osoba values( 1, 1, 'Jan', 'Kowalski', 1000 );
  insert into Osoba values( 2, 3, 'Ewa', 'Solska', 1200 );
  insert into Osoba values( 3, 2, 'Boydar', 'Nowak', 1500 );
  insert into Osoba values( 4, 4, 'Adam', 'Adamski', 1700 );
  insert into Osoba values( 5, 4, 'Zygmunt', 'Riposta', 1240 );
  insert into Osoba values( 6, 2, 'Alicja', 'Gleba', 1600 );
  insert into Osoba values( 7, 1, 'Tania', 'Borwka', 1560 );
  insert into Osoba values( 8, 1, 'Natasza', 'Lizacka', 2500 );
  insert into Osoba values( 9, 3, 'Stan', 'Taczkowski', 1900 );
end;

select * from Osoba o, Jednostka j where o.ID_Jednostka = j.ID;
*/

 import java.sql.*;
 
 import javax.sql.rowset.*;
 import com.sun.rowset.*;
 
 public class JoinRowSetSample {
    
    public static void main(String [] args) {
       
        String dbUrl = "jdbc:oracle:thin:@localhost:1521:XE";
        String dbUserId = "pawel";
        String dbPasswd = "oracle10g";
        String dbDriver = "oracle.jdbc.driver.OracleDriver";
              
       try {
          Class.forName(dbDriver);
       } catch(Exception e) {
          System.out.println("Unable to load driver: "+e.getMessage());
          System.exit(1);
       }
       
       try
       {
       
          Connection con = DriverManager.getConnection(dbUrl,dbUserId,dbPasswd);                    
          
          Statement stmtJednostka = con.createStatement();
          ResultSet rsJednostka = stmtJednostka.executeQuery("select ID IDJ, Nazwa from Jednostka");
          
          Statement stmtOsoba = con.createStatement();
          ResultSet rsOsoba = stmtOsoba.executeQuery("select ID, ID_Jednostka, Imie, Nazwisko, Pensja from Osoba order by ID");
          
          CachedRowSet crsJednostka = new CachedRowSetImpl();
          crsJednostka.setMatchColumn(1);
          crsJednostka.populate(rsJednostka);
          System.out.println("Size of the first cached rowset is: "+crsJednostka.size());
          
          CachedRowSet crsOsoba = new CachedRowSetImpl();
          crsOsoba.setMatchColumn("ID_Jednostka");
          crsOsoba.populate(rsOsoba);
          System.out.println("Size of the first cached rowset is: "+crsOsoba.size());
          
          JoinRowSet jrs = new JoinRowSetImpl();
          jrs.addRowSet(crsJednostka);
          jrs.addRowSet(crsOsoba);
          
          System.out.println("Size of the joinRowSet is: "+jrs.size());
          System.out.println("Contents are");
          
          while(jrs.next()) {
                System.out.println(String.format("%s %s %s %s", jrs.getString("ID"), jrs.getString(2), jrs.getString("Imie"), jrs.getString("Nazwisko")));
          }
     
          con.close();          
          rsJednostka.close();
          rsOsoba.close();
          crsJednostka.close();
          crsOsoba.close();
          jrs.close();          
    } catch (SQLException sqle) {
        System.out.println("SQLException caught: "+sqle.getMessage());
    } catch (Exception e) {
        System.out.println("Unexpected Exception caught: "+e.getMessage());
    }
  }
}